import { toLowerCaseWithoutSpaces } from './helpers';
import { ITestCase, IScenario } from './types';

/**
 * Feature Boilerplate
 * @param testCase
 */
export const featureBoilerplate = (testCase: ITestCase) => {
  const splitName = testCase.feature.split('.');
  const primaryTag = `@${testCase.feature.split('.')[1].toUpperCase()}`;
  return `
  #
  ##
  ### WARNING: THIS FILE IS AUTO-GENERATED, ANY CHANGES TO THIS FILE WILL BE OVERWRITTEN
  ##
  #
  ${primaryTag}
  @SLOW
  @DO_NOT_RUN_YET
  
 
  Feature: (${splitName[0].toUpperCase()}) ${splitName[1]} Promotion FE02 Test Cases
  This is an auto-generated feature based on the product promotion matrix, and the FE02 rules that then follow`;
};

/**
 * Generate Scenario Steps
 * @param testCase
 * @param scenario
 */
export const generateScenario = (testCase: ITestCase, scenario: IScenario) => {
  const cucumber: string[] = [];

  //
  // Constants
  //
  const featureName = toLowerCaseWithoutSpaces(testCase.feature);
  const seedFileName = `${toLowerCaseWithoutSpaces(testCase.feature)}.${toLowerCaseWithoutSpaces(
    scenario.lineType
  )}`;
  const seedEmailAddress = `${toLowerCaseWithoutSpaces(
    testCase.feature
  )}.${toLowerCaseWithoutSpaces(scenario.loggedInState)}@project.local`;
  const isGuest = scenario.loggedInState === 'Guest';

  //
  // Steps
  //
  cucumber.push(`Scenario: ${scenario.name}`);
  cucumber.push(`Given I seed using the file "${seedFileName}"`);
  cucumber.push(`And I set the local storage key "userSelectedCountry" with the content "GBR"`);
  if (!isGuest) {
    cucumber.push(`And I login with "${seedEmailAddress}" and "autoGenerated"`);
  }
  cucumber.push(`And I open the page "/checkout"`);
  if (isGuest) {
    cucumber.push(
      `When I set "${featureName} User" to the inputfield "CheckoutAddress.firstNameTextbox"`
    );
    cucumber.push(`And I set "lastName" to the inputfield "CheckoutAddress.lastNameTextbox"`);
    cucumber.push(`And I set "123123123" to the inputfield "CheckoutAddress.phoneTextbox"`);
    cucumber.push(
      `And I set "${seedEmailAddress}" to the inputfield "CheckoutAddress.emailAddressTextbox"`
    );
    cucumber.push(
      `And I set "${seedEmailAddress}" to the inputfield "CheckoutAddress.confirmEmailAddressTextbox"`
    );
    cucumber.push(`And I set "address1" to the inputfield "CheckoutAddress.address1Textbox"`);
    cucumber.push(`And I set "city" to the inputfield "CheckoutAddress.cityTextbox"`);
    cucumber.push(`And I set "GL51 9NH" to the inputfield "CheckoutAddress.postcodeTextbox"`);
  }
  cucumber.push(`And I complete a ${scenario.paymentType} payment`);
  cucumber.push(`And I download the FE02 file from S3`);
  cucumber.push(
    `Then I expect the FE02 path "//oms:PaymentMethod" has attribute "PaymentType" with value "${scenario.paymentType}"`
  );

  for (const node of scenario.checkNodes) {
    for (const attribute of node.checkAttributes) {
      cucumber.push(
        `And I expect the FE02 path "${node.name}" has attribute "${attribute.name}" with value "${attribute.value}"`
      );
    }
  }

  //
  // Format and return
  //
  const formattedCucumber = cucumber.map((line) => {
    let formattedLine = '';
    if (line.indexOf('Scenario:') > -1) {
      formattedLine += `\r\n\r\n\t${line}`;
    } else if (line.indexOf('And ') > -1) {
      formattedLine += `\t\t\t${line}`;
    } else {
      formattedLine += `\t\t${line}`;
    }
    return formattedLine;
  });
  return formattedCucumber.join('\r\n');
};
